#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>

int PRICE_LENGTH = 17161; //csv.length - header
int STRING_MAX_SIZE = 1024;

char alias[135][100] = {
    // BR - u
    "BR01","BR02","BR03","BR04","BR05","BR06","BR07","BR08","BR09","BR10",
    "BR11","BR12","BR13","BR14","BR15","BR16","BR17","BR18","BR19","BR20",
    "BR21","BR22","BR23","BR24",
    // R - HHqu
    "R02","R03","R04","R05","R06","R07","R08","R09","R10","R11",
    "R12","R13","R14","R15","R16","R17","R18","R19","R20","R21",
    "R22","R22A","R23","R24","R25","R26","R27","R28",
    // G - Qssu
    "G01","G02","G03","G03A","G04","G05","G06","G07","G08","G09",
    "G10","G11","G12","G13","G14","G15","G16","G17","G18","G19",
    // O - MsĪu
    "O01","O02","O03","O04","O05","O06","O07","O08","O09","O10",
    "O11","O12","O13","O14","O15","O16","O17","O18","O19","O20",
    "O21","O50","O51","O52","O53","O54",
    // BL - Onu
    "BL01","BL02","BL03","BL04","BL05","BL06","BL07","BL08","BL09","BL10",
    "BL11","BL12","BL13","BL14","BL15","BL16","BL17","BL18","BL19","BL20",
    "BL21","BL22","BL23",
    // Y - u
    "Y07","Y08","Y09","Y10","Y11","Y12","Y13","Y14","Y15","Y16",
    "Y17","Y18","Y19","Y20"
};
char alias_CHI[135][100] = {
    // BR - u
    "ʪ","]","Uڪ","U|","","","ip","ޤj","jw","_",
    "nʴ_","sꤤ","Qs","j","Cn","","Y","w","","j򤽶",
    "w","F","nn","ni]",
    // R - HHqu
    "Hs","x_101/@T","HqwM","jw","jw˪L","F","","xj|","x_","s",
    "s","v","s","C","hL","ۤs","w","۵P","ԧ","_",
    "_","s_","_^","q","","˳","L","H",
    // G - Qssu
    "s","sϤ","Ci","pѼ","jWL","","U","]","xqj","jF",
    "","pn","","_","s","Qn","nʴ_","x_pJ","nʤT","Qs",
    // O - MsĪu
    "nը","w","æw","","jF","F","s","Qn","Ѯc","sp",
    "v","jY","x_","d","T","ޮc","Ye","s","j","",
    "js","Tp","TMꤤ","}פ","T","Īw",
    // BL - Onu
    "H","ù","g","s","ȪF|","","O","sH","lA","ssx",
    "","x_","ɦx","s","_","","]","F","ìK","s",
    "","n","ni]",
    // Y - u
    "jWL","̥|i","qԾ","","w","M","M","","Os","O",
    "sH","Ye","","s_~"
};

void readPriceCsv(char from[PRICE_LENGTH][50], char to[PRICE_LENGTH][50], int* adult, int* elder, int* child) {
    FILE* price = fopen("price.csv", "r");

    char useless[5][STRING_MAX_SIZE]; // For Header

    // handle FileNotFoundException
    if(!price){fprintf(stderr, "file to open csv file");}

    fseek(price, 0, SEEK_SET);

    char line[STRING_MAX_SIZE]; // for storage csv.eachLine
    char* result = NULL; // for storage csv.eachLine.split(',')
    int count = 0; // while loop indicator
    while(fgets(line, STRING_MAX_SIZE, price) != NULL){
        result = strtok(line, ","); 
        for(int i=0; i<5; i++){
            // printf("%d - %d: %s\n", count, i, result); // *Debug Only
            if(count == 0){
                strncpy(useless[i], result, strlen(result) + 1); // Header
            } else {
                switch(i) {
                    case 0: // From
                        strcpy(from[count-1], result);
                        break;
                    case 1: // To
                        strcpy(to[count-1], result);
                        break;
                    case 2: // Price of Adult
                        adult[count-1] = atoi(result);
                        break;
                    case 3: // Price of Elder
                        elder[count-1] = atoi(result);
                        break;
                    case 4: // Price of Children
                        child[count-1] = atoi(result);
                        break;
                }
            }
            result = strtok(NULL, ",");
        }
        count++; // Indicator++ : prevent infinity loop
    }

    fclose(price);
}

#define BUFFER_RANGE 65536

int fetchData(int from, char* to) {
    FILE* price = fopen("duration.txt", "r");
    char line[BUFFER_RANGE];
    int count = 0; // while loop count
    while(fgets(line, BUFFER_RANGE, price) != NULL){
        //brute force split json-object
        if(count == from){ // read txt specific line: represent corrospoding timelist (Starting-point to different End-point)
            char* result = strtok(line, "\""); // split by "
            char temp[100]; // for storage splited string
            int nextLine = 0; // a variable to define what to do
            while(result != "}"){
                // 1: start code, 2: endcode ~:3: start time 4: end time, 5 = 1
                if(nextLine == 2){ // Eg: {"A01":"=>15"}
                    return atoi(result);
                    nextLine = 0; // skip this stupid function
                } else if(nextLine == 1){ // skip: Eg: {"A01"=>:"15"}
                    nextLine++;
                }
                strcpy(temp, result);
                if(strcmp(temp, to) == 0){ //Found Location: Eg: {=>"A01":"15"}
                    nextLine = 1;
                }
                result = strtok(NULL, "\"");
            }

        }
        count++;
    }
    return 0; //represent error
}
int duration;

int printAlias(){
    int j=1;

    for(int i=0; i<135; i++){
        printf("%s - %s    ", alias[i],alias_CHI[i]);
        if(i == 23 || i == 51 || i == 71 || i == 97 || i == 120 || i == 134){
            j=1;
            printf("\n\n");
        } else {
            if(j%5==0 && j!=0){
            	printf("\n");
			}
			else{
				if(i==22 || i==25 || i==114){
					printf("\t");
				}
				else
				printf("   \t");
			}
			j++;
        }
        
    }
}

int durationAndPrice(char start[100],char end[100],int identity) {
    setlocale(LC_ALL, "UTF-8"); // set for chinese character ! useless?

    #pragma region hardCode


    //parameters
    int index_start = -1, index_end = -1;
    while(index_start < 0){ // set index when found string
        for(int i=0; i<135; i++){
            if(strcmp(alias[i], start) == 0){ // ! Code Only
                index_start = i;
            }
        }
    }
    while(index_end < 0 || index_end == index_start){
        for(int i=0; i<135; i++){
            if(strcmp(alias[i], end) == 0){ // ! Code Only
                index_end = i;
            }
        }
    }

    #pragma endregion hardCode

    #pragma region readPrice

    char from[PRICE_LENGTH][50], to[PRICE_LENGTH][50];
    int adult[17161], elder[17161], child[17161];
    readPriceCsv(from, to, adult, elder, child);

    #pragma region fetchHttpRequest->fail->readJson

    duration = fetchData(index_start, alias[index_end]);

    #pragma endregion fetchHttpRequest->fail->readJson

    #pragma endregion readPrice
    
    #pragma region printPrice
    
    int price=0;
    for(int i=0; i<PRICE_LENGTH; i++){

        if(strcmp(alias_CHI[index_start], from[i]) == 0 && strcmp(alias_CHI[index_end], to[i]) == 0){
            switch (identity)
            {
            case 0:
            {
                return adult[i];
            }
            case 1:
            {
                return elder[i];
            }
            case 2:{
                return child[i];
            }
            }
        }
    }
    

    #pragma endregion printPrice
}

int returnDuration(){
    return duration;
}